%% Problemi Uretme
xc = [1, 4; 4, 3; 3, 1]; % Merkezler
N = 100; n=2; 
C = 3; % Sinif sayisi
x = zeros(N, n);
y = zeros(N, 1);
clf; hold on;
for k=1:N
    l = randperm(C, 1); % Bir sinifi rassal olarak sec
    x(k, :) = mvnrnd(xc(l, :), 0.2*eye(2));
    y(k) = l;
    if (l==1)
        scatter(x(k, 1), x(k, 2), 20, 'b');
    elseif (l==2)
        scatter(x(k, 1), x(k, 2), 20, 'r');
    else
        scatter(x(k, 1), x(k, 2), 20, 'g');
    end
end
text(xc(1,1), xc(1,2), '1. SINIF');
text(xc(2,1), xc(2,2), '2. SINIF');
text(xc(3,1), xc(3,2), '3. SINIF');

% Baslangic cozumu
theta0 = rand(C, n);

%% Cozum
tic
theta = theta0;
alpha = 1;
maxiter = 10000;
for i=1:maxiter
    DJ = ooy(x, y, theta, 'rgi'); % Yigin Gradyant Inis ile turev hesapla
    theta = theta - alpha*DJ;
    alpha = 1.0e-5*(1/sqrt(i));
    if (norm(DJ, 'inf')<1.0e-4)
        break;
    end
end
toc;


%% Test
xtest = [3; 1];
fprintf('(%.2f, %.2f) Noktasi \n', xtest(1), xtest(2));

denom = 0;
for l=1:C
    denom = denom + exp(theta(l, :)*xtest);
end
    
for j=1:C
    num = exp(theta(j, :)*xtest);
    fprintf('\t%d sinifina ait olma olasiligi: %f\n', j, num/denom);
end